<?php

/**
 * Back-End of Ajaxfilemanager_XH.
 *
 * Copyright (c) 2011-2012 Christoph M. Becker (see license.txt)
 */


// utf-8-marker: äöüß


if (!defined('CMSIMPLE_XH_VERSION')) {
    header('HTTP/1.0 403 Forbidden');
    exit;
}


define('AJAXFILEMANAGER_VERSION', '1beta4');


/**
 * Returns plugin version information.
 *
 * @return string  The (X)HTML.
 */
function ajaxfilemanager_version() {
    return '<h1><a href="http://3-magi.net/?CMSimple_XH/Ajaxfilemanager_XH">Ajaxfilemanager_XH</a></h1>'."\n"
	    .'<p>Version: '.AJAXFILEMANAGER_VERSION.'</p>'."\n"
	    .'<p>Ajaxfilemanager_XH is powered by '
	    .'<a href="http://www.phpletter.com/Our-Projects/Ajax-File-Manager-Project/">'
	    .'Ajax File Manager</a>.</p>'."\n"
	    .'<p>Copyright &copy; 2011-2012 <a href="http://3-magi.net">Christoph M. Becker</a></p>'."\n"
	    .'<p style="text-align: justify">This program is free software: you can redistribute it and/or modify'
	    .' it under the terms of the GNU General Public License as published by'
	    .' the Free Software Foundation, either version 3 of the License, or'
	    .' (at your option) any later version.</p>'."\n"
	    .'<p style="text-align: justify">This program is distributed in the hope that it will be useful,'
	    .' but WITHOUT ANY WARRANTY; without even the implied warranty of'
	    .' MERCHAN&shy;TABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the'
	    .' GNU General Public License for more details.</p>'."\n"
	    .'<p style="text-align: justify">You should have received a copy of the GNU General Public License'
	    .' along with this program.  If not, see'
	    .' <a href="http://www.gnu.org/licenses/">http://www.gnu.org/licenses/</a>.</p>'."\n";
}


/**
 * Returns requirements information.
 *
 * @return string  The (X)HTML.
 */
function ajaxfilemanager_system_check() { // RELEASE-TODO
    global $pth, $tx, $plugin_tx;

    define('AJAXFILEMANAGER_PHP_VERSION', '4.3.2');
    $ptx = $plugin_tx['ajaxfilemanager'];
    $imgdir = $pth['folder']['plugins'].'ajaxfilemanager/images/';
    $ok = tag('img src="'.$imgdir.'ok.png" alt="ok"');
    $warn = tag('img src="'.$imgdir.'warn.png" alt="warning"');
    $fail = tag('img src="'.$imgdir.'fail.png" alt="failure"');
    $htm = tag('hr').'<h4>'.$ptx['syscheck_title'].'</h4>'
	    .(version_compare(PHP_VERSION, AJAXFILEMANAGER_PHP_VERSION) >= 0 ? $ok : $fail)
	    .'&nbsp;&nbsp;'.sprintf($ptx['syscheck_phpversion'], AJAXFILEMANAGER_PHP_VERSION)
	    .tag('br').tag('br')."\n";
    foreach (array('date', 'gd', 'pcre', 'session') as $ext) {
	$htm .= (extension_loaded($ext) ? $ok : $fail)
		.'&nbsp;&nbsp;'.sprintf($ptx['syscheck_extension'], $ext).tag('br')."\n";
    }
    $htm .= tag('br').(strtoupper($tx['meta']['codepage']) == 'UTF-8' ? $ok : $warn)
	    .'&nbsp;&nbsp;'.$ptx['syscheck_encoding'].tag('br')."\n";
    $htm .= (!get_magic_quotes_runtime() ? $ok : $warn)
	    .'&nbsp;&nbsp;'.$ptx['syscheck_magic_quotes'].tag('br').tag('br')."\n";
    foreach (array('config/', 'css/', 'languages/', 'lib/langs/') as $folder) {
	$htm .= (is_writable($pth['folder']['plugins'].'ajaxfilemanager/'.$folder) ? $ok : $warn)
		.'&nbsp;&nbsp;'.sprintf($ptx['syscheck_writable'], $folder).tag('br')."\n";
    }
    return $htm;
}


/**
 * Activate the filemanager from the back-end
 */
if ((isset($cf['filebrowser']['external']) && $cf['filebrowser']['external'] == 'ajaxfilemanager'
	|| !isset($cf['filebrowser']['external']))
	&& (isset($images) && $images || isset($downloads) && $downloads
	|| isset($media) && $media || isset($userfiles) && $userfiles)) {
    include_once($pth['folder']['plugins'].'ajaxfilemanager/init.php');
    $f = isset($images) && $images ? 'images'
	    : (isset($downloads) && $downloads ? 'downloads'
	    : (isset($media) && $media ? 'media'
	    : (isset($userfiles) && $userfiles ? 'userfiles' : NULL)));
    $ajaxfilemanager_url = $pth['folder']['plugins']
		.'ajaxfilemanager/lib/ajaxfilemanager.php?editor=stand_alone'
		.'&amp;language='.(strlen($sl) == 2 ? $sl : $cf['language']['default'])
		.'&amp;type='.$f.'&amp;theme='.$plugin_cf['ajaxfilemanager']['theme'];
    $o .= '<div id="ajaxfilemanager-container">'."\n"
	    .'<h1>'.$tx['title'][$f].'</h1>'
	    .'<iframe id="ajaxfilemanager" src="'.$pth['folder']['plugins']
		.'ajaxfilemanager/lib/ajaxfilemanager.php?editor=stand_alone'
		.'&amp;language='.(strlen($sl) == 2 ? $sl : $cf['language']['default'])
		.'&amp;type='.$f.'&amp;theme='.$plugin_cf['ajaxfilemanager']['theme']
		.'"'
		.' frameborder="0">'
	    .'</iframe>'."\n"
	    .'</div>'."\n";
    $hjs .= '<script type="text/javascript">'."\n"
	    .'/* <![CDATA[ */'."\n"
	    .'var AJAXFILEMANAGER_FULLSCREEN = '.($plugin_cf['ajaxfilemanager']['default_fullscreen'] ? 'true' : 'false').';'."\n"
	    .'/* ]]> */'."\n"
	    .'</script>'."\n";
    $images = $downloads = $userfiles = $media = FALSE;
    $f = 'filebrowser';
}


/**
 * Plugin administration
 */
if (isset($ajaxfilemanager)) {
    initvar('admin');
    initvar('action');

    $o .= print_plugin_admin('off');

    switch ($admin) {
	case '':
	    $o .= ajaxfilemanager_version().ajaxfilemanager_system_check();
	    break;
	default:
	    $o .= plugin_admin_common($action, $admin, $plugin);
    }
}

?>
