<?php

/**
 * Initialization of Ajaxfilemanager_XH.
 *
 * Copyright (c) 2011-2012 Christoph M. Becker (see license.txt)
 */


// utf-8-marker: äöüß


if (!defined('CMSIMPLE_XH_VERSION')) {
    header('HTTP/1.0 403 Forbidden');
    exit;
}


/**
 * Updates the LANG.php file for Ajaxfilemanager if necessary.
 *
 * @return bool
 */
function ajaxfilemanager_update_lang() {
    global $pth, $sl, $plugin_tx;

    $ptx = $plugin_tx['ajaxfilemanager'];

    $srcdir = $pth['folder']['plugins'].'ajaxfilemanager/languages/';
    $dstdir = $pth['folder']['plugins'].'ajaxfilemanager/lib/langs/';
    if (!file_exists($srcdir.$sl.'.php')) {
	if (file_exists($srcdir.'default.php')) {
	    if (!copy($srcdir.'default.php', $srcdir.$sl.'.php')) {
		e('cntwriteto', 'language', $srcdir.$sl.'.php');
	    }
	} else {
	    e('missing', 'language', $srcdir.'default.php');
	}
    }
    if (!file_exists($dstdir.$sl.'.php') || filemtime($dstdir.$sl.'.php') < filemtime($srcdir.$sl.'.php')) {
	$php = '<?php'."\n\n"
		.'// auto-generated by Ajaxfilemanager_XH -- do not modify!'."\n\n"
		.'// utf-8-marker: äöüß'."\n\n";
	$first = TRUE;
	foreach ($ptx as $key => $msg) {
	    $parts = explode('_', $key);
	    if (in_array($parts[0],
		    array('btn', 'calendar', 'date', 'err', 'file', 'folder', 'img',
			'lbl', 'login', 'menu', 'new', 'pagination', 'preview', 'rename',
			'search', 'session', 'sys', 'txt', 'thickbox', 'tip', 'warning'))) {
		if ($first) {
		    $first = FALSE;
		} else {
		    $php .= "\n";
		}
		$php .= 'define(\''.strtoupper($key).'\', \''.addslashes($msg).'\');';
	    }
	}
	$php .= "\n\n".'?>'."\n";
	if (!($fh = fopen($pth['folder']['plugins'].'ajaxfilemanager/lib/langs/'.$sl.'.php', 'w')) || ($res = fwrite($fh, $php)) === FALSE) {
	    e('cntwriteto', 'file', $dstdir.$sl.'.php');
	}
	if ($fh) {fclose($fh);}
    }
}


/**
 * Initializes the session.
 *
 * @return void
 */
function ajaxfilemanager_init() {
    global $adm, $pth, $sl, $cf, $plugin_cf;

    if (!$adm) {return;}
    include_once $pth['folder']['plugins'].'ajaxfilemanager/config/config.php';
    ajaxfilemanager_update_lang();
    if (!isset($_SESSION)) {session_start();}
    $_SESSION['ajaxfilemanager_adm'] = $adm;
    $_SESSION['ajaxfilemanager_pwd'] = dirname(__FILE__);
    $_SESSION['ajaxfilemanager_cms_url'] = 'http://'.$_SERVER['SERVER_NAME'].CMSIMPLE_ROOT;
    if ($sl == $cf['language']['default']) {
	$prefix = '../../../';
	$_SESSION['ajaxfilemanager_cms_prefix'] = './';
	$_SESSION['ajaxfilemanager_cms_subsite'] = '';
    } else {
	$prefix = '../../';
	$_SESSION['ajaxfilemanager_cms_prefix'] = '../';
	$_SESSION['ajaxfilemanager_cms_subsite'] = $sl.'/';
    }
    foreach (array('images', 'downloads', 'media', 'userfiles') as $type) {
	if (isset($pth['folder'][$type])) {
	    $_SESSION['ajaxfilemanager_folder'][$type] =
		    $prefix.$pth['folder'][$type];
	    $_SESSION['ajaxfilemanager_upload_extensions'][$type] =
		    $plugin_cf['ajaxfilemanager']['extensions_'.$type];
	}
    }
    foreach (array('upload_max_size', 'preview_width', 'preview_height',
	    'default_view', 'default_pagination', 'urls_relative', 'load_docs_late') as $i) {
	$_SESSION['ajaxfilemanager_'.$i] = $plugin_cf['ajaxfilemanager'][$i];
    }
}


ajaxfilemanager_init();

?>
