<?php

// utf-8-marker: äöüß

include_once(dirname(__FILE__).DIRECTORY_SEPARATOR.'inc'.DIRECTORY_SEPARATOR.'config.php');
$error = '';
$fileMoved = array();
$unmovedDocDueToSamePath = array();
if (CONFIG_SYS_VIEW_ONLY || !CONFIG_OPTIONS_CUT && !CONFIG_OPTIONS_COPY) {
    $error = SYS_DISABLED;
} elseif (empty($_GET['current_folder_path'])) {
    $error = ERR_NOT_DEST_FOLDER_SPECIFIED;
} elseif (!file_exists($_GET['current_folder_path']) || !is_dir($_GET['current_folder_path'])) {
    $error = ERR_DEST_FOLDER_NOT_FOUND;
} elseif (!isUnderRoot($_GET['current_folder_path'])) {
    $error = ERR_DEST_FOLDER_NOT_ALLOWED;
} else {
    include_once(CLASS_MANAGER);
    include_once(CLASS_SESSION_ACTION);
    $sessionAction = new SessionAction();
    include_once(DIR_AJAX_INC.'class.manager.php');
    $manager = new manager();
    $manager->setSessionAction($sessionAction);
    $selectedDocuments = $sessionAction->get();
    $destFolderPath = addTrailingSlash(backslashToSlash($_GET['current_folder_path']));
    if (count($selectedDocuments)) {
	include_once(CLASS_FILE);
	$file = new file();
	foreach ($selectedDocuments as $doc) {
	    if (file_exists($doc) && isUnderRoot($doc)
		    && ($sessionAction->getAction() != 'cut' || $doc != $destFolderPath.basename($doc))) {
		if ($doc != $destFolderPath) {
		    $finalPath = $file->getNextAvailableFileName($doc, $_GET['current_folder_path']);
		    if ($file->copyTo($doc, $_GET['current_folder_path'])) {
			$objFile = new file($finalPath);
			$tem = $objFile->getFileInfo();
			$obj = new manager($finalPath, FALSE);
			$fileType = $obj->getFileType($finalPath, is_dir($finalPath) ? TRUE : FALSE);
			foreach ($fileType as $k => $v) {$tem[$k] = $v;}
			$tem['final_path'] = $finalPath;
			$tem['path'] = backslashToSlash($finalPath);
			$tem['type'] = is_dir($finalPath) ? 'folder' : 'file';
			$tem['size'] = @transformFileSize($tem['size']);
			$tem['ctime'] = date(DATE_TIME_FORMAT, $tem['ctime']);
			$tem['mtime'] = date(DATE_TIME_FORMAT, $tem['mtime']);
			$tem['flag'] = 'noFlag';
			$tem['url'] = getFileUrl($finalPath);
			$manager = null;
			if ($sessionAction->getAction() == 'cut') {$file->delete($doc);}
			$fileMoved[] = $tem;
			$tem = null;
		    }
		} else {
		    $unmovedDocDueToSamePath[] = $doc;
		}
	    }
	}
	$sessionAction->set(array());
    }
    if (count($unmovedDocDueToSamePath) == count($selectedDocuments)) {
	$error = ERR_DEST_FOLDER_NOT_ALLOWED;
    } elseif (count($unmovedDocDueToSamePath)) {
	foreach ($unmovedDocDueToSamePath as $v) {
	    $error .=  sprintf(ERR_UNABLE_TO_MOVE_TO_SAME_DEST, $v)."\n";
	}
    }
}

echo '{"error": "'.$error.'", "unmoved_files": "'.count($unmovedDocDueToSamePath).'", "files": {';
foreach ($fileMoved as  $i => $file) {
    echo ($i > 0 ? ', ' : '').'"'.$i.'": {';
    $j = 0;
    foreach($file as $k => $v) {
	echo ($j++ > 0 ? ', ' : '').'"'.$k.'":"'.$v.'"';
    }
    echo '}';
}
echo '}}';

?>
